%define	major 2
%define libname %mklibname spread %{major}
%define develname %mklibname spread -d

Summary:	Multicast Group Communication Framework
Name:		spread
Version:	4.1.0
Release:	%mkrel 14
Group:		System/Servers
License:	BSD-style
URL:		http://www.spread.org/
Source0:	spread-src-%{version}.tar.gz
Source2:	spread.init
Source3:	spread.sysconfig
Patch1:		spread-mdv_config.diff
Patch2:		spread-src-force_man_page_format.diff
Requires(post): systemd >= %{systemd_required_version}
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
Requires(postun): rpm-helper
BuildRequires:	flex
BuildRequires:	groff-for-man

%description
Spread is a toolkit that provides a high performance messaging service that is
resilient to faults across external or internal networks. Spread functions as a
unified message bus for distributed applications, and provides highly tuned
application-level multicast and group communication support. Spread services
range from reliable message passing to fully ordered messages with delivery
guarantees, even in case of computer failures and network partitions. Spread is
designed to encapsulate the challenging aspects of asynchronous networks and
enable the construction of scalable distributed applications, allowing
application builders to focus on the differentiating components of their
application.

%package -n	%{libname}
Summary:	Multicast Group Communication Framework library
Group:          System/Libraries

%description -n	%{libname}
Spread is a toolkit that provides a high performance messaging service that is
resilient to faults across external or internal networks. Spread functions as a
unified message bus for distributed applications, and provides highly tuned
application-level multicast and group communication support. Spread services
range from reliable message passing to fully ordered messages with delivery
guarantees, even in case of computer failures and network partitions. Spread is
designed to encapsulate the challenging aspects of asynchronous networks and
enable the construction of scalable distributed applications, allowing
application builders to focus on the differentiating components of their
application.

%package -n	%{develname}
Summary:	Static library and header files for the libevent library
Group:		Development/C
Requires:	%{libname} = %{version}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Obsoletes:	%{mklibname spread 1 -d}

%description -n	%{develname}
Spread is a toolkit that provides a high performance messaging service that is
resilient to faults across external or internal networks. Spread functions as a
unified message bus for distributed applications, and provides highly tuned
application-level multicast and group communication support. Spread services
range from reliable message passing to fully ordered messages with delivery
guarantees, even in case of computer failures and network partitions. Spread is
designed to encapsulate the challenging aspects of asynchronous networks and
enable the construction of scalable distributed applications, allowing
application builders to focus on the differentiating components of their
application.

This package includes the necessary files to develop systems with Spread.

%prep

%setup -q -n spread-src-%{version}
%patch1 -p0 -b .mdv_config
%patch2 -p1 -b .force_man_page_format

cp %{SOURCE2} spread.init
cp %{SOURCE3} spread.sysconfig

%build
%configure \
    --with-mantype=man \
    --with-pid-dir=/run/spread

%make_build

%install
%make_install

install -d %{buildroot}%{_sysconfdir}/{sysconfig,logrotate.d}
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}/var/log/spread

install -m0644 docs/sample.spread.access_ip %{buildroot}%{_sysconfdir}/spread.access_ip
install -m0755 spread.init %{buildroot}%{_initrddir}/spread
install -m0644 spread.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/spread

touch %{buildroot}/var/log/spread/spread.log

# install log rotation stuff
cat > %{buildroot}%{_sysconfdir}/logrotate.d/spread << EOF
/var/log/spread/spread.log {
    create 644 spread spread
    monthly
    compress
    missingok
    postrotate
	/bin/kill -HUP \`cat /run/spread/spread.pid 2> /dev/null\` 2> /dev/null || true
    endscript
}
EOF

mkdir -p %{buildroot}%{_tmpfilesdir}
cat <<EOF > %{buildroot}%{_tmpfilesdir}/%{name}.conf
d /run/spread 0755 spread spread
EOF

%pre
%_pre_useradd spread /run/spread /bin/false

%post
%_tmpfilescreate %{name}
%create_ghostfile /var/log/spread/spread.log spread spread 0644
%_post_service spread

%preun
%_preun_service spread

%postun
%_postun_userdel spread

%files
%doc license.txt release_announcement_*.txt CVS_Readme.txt Readme.txt
%doc docs/PORTING docs/*.txt docs/TODO docs/*.pdf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/spread.*
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/spread
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/spread
%{_tmpfilesdir}/%{name}.conf
%attr(0755,root,root) %{_initrddir}/spread
%{_bindir}/flush_user
%{_bindir}/sp*
%{_mandir}/man1/*
%attr(0755,spread,spread) %dir /var/log/spread
%attr(0644,spread,spread) %ghost /var/log/spread/spread.log

%files -n %{libname}
%{_libdir}/lib*.so.%{major}{,.*}

%files -n %{develname}
%{_libdir}/lib*.so
%{_libdir}/lib*.a
%{_includedir}/*
%{_mandir}/man3/*


%changelog
* Wed Aug 19 2020 joequant <joequant> 4.1.0-14.mga8
+ Revision: 1615762
- fix build
- revert arm fix

* Fri Feb 14 2020 umeabot <umeabot> 4.1.0-13.mga8
+ Revision: 1517158
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sun Sep 23 2018 umeabot <umeabot> 4.1.0-12.mga7
+ Revision: 1301150
- Mageia 7 Mass Rebuild

* Sun Jul 08 2018 wally <wally> 4.1.0-11.mga7
+ Revision: 1242622
- fix build on aarch64

* Wed Feb 17 2016 umeabot <umeabot> 4.1.0-10.mga6
+ Revision: 962903
- Mageia 6 Mass Rebuild

* Thu Oct 22 2015 daviddavid <daviddavid> 4.1.0-9.mga6
+ Revision: 894308
- add more docs to fix build with latest rpm

* Wed Oct 15 2014 umeabot <umeabot> 4.1.0-8.mga5
+ Revision: 743921
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 4.1.0-7.mga5
+ Revision: 689290
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 4.1.0-6.mga4
+ Revision: 522679
- Mageia 4 Mass Rebuild

* Sun Mar 24 2013 colin <colin> 4.1.0-5.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

* Mon Jan 14 2013 umeabot <umeabot> 4.1.0-4.mga3
+ Revision: 382526
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild
+ luigiwalser <luigiwalser>
- add tmpfiles config for /run/spread

* Sun Apr 29 2012 colin <colin> 4.1.0-3.mga2
+ Revision: 234234
- Add LSB headers to initscripts (mga#5262)

* Mon Jan 24 2011 erwan <erwan> 4.1.0-2.mga1
+ Revision: 37998
- imported package spread

